function [P,L,U]=PALU_Cpt(A)
% permuted LU factorization for 3D-array
%   P*A=L*U
  assert( fc_linalg3D.is3Darray(A) )
  [N,m,n]=size(A);
  assert( m==n )
  L=fc_linalg3D.eye(N,m);
  U=A;
  P=fc_linalg3D.eye(N,m);
  for k=1:N
    for i=1:m-1
      [~,idx]=max(abs(U(k,i:end,i)));
      mu=idx(1)+i-1;
      if abs(U(k,mu,i))> 1e-15
        if i~=mu
          U(k,[i,mu],i:end)=U(k,[mu,i],i:end);
          L(k,[i,mu],1:i-1)=L(k,[mu,i],1:i-1);
          P(k,[i,mu],:)=P(k,[mu,i],:);
        end
        for j=i+1:m
          L(k,j,i)=U(k,j,i)/U(k,i,i);
          U(k,j,i:end)=U(k,j,i:end)-L(k,j,i)*U(k,i,i:end);
        end
      end
    end
  end
  if nargout==1, P={P,L,U};end
end
